﻿<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet
  version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:store="http://schemas.microsoft.com/robotics/2007/06/sqlstore.html" 
  xmlns:n="http://schemas.microsoft.com/robotics/2007/06/northwind.html">

  <xsl:import href="/resources/dss/Microsoft.Dss.Runtime.Home.MasterPage.xslt" />

  <xsl:template match="/">
    <xsl:call-template name="MasterPage">
      <xsl:with-param name="serviceName">
        SQL Client NorthWind Sample
      </xsl:with-param>
      <xsl:with-param name="description">
        The SQL client enables access to a SQL server using GET, QUERY, UPDATE, INSERT, UPSERT, and DELETE.
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="/store:SqlStoreState">
    <table width="100%">
      <tr>
        <th>Customer ID</th>
        <th>Company Name</th>
        <th>ContactName</th>
        <th>ContactTitle</th>
        <th>Address</th>
        <th>City</th>
        <th>PostalCode</th>
        <th>Country</th>
        <th>Phone</th>
        <th>Fax</th>
      </tr>
      <xsl:apply-templates select="//n:Customers" />
    </table>
  </xsl:template>
  
  <xsl:template match="//n:Customers">
    <tr>
      <xsl:attribute name="class">
        <xsl:choose>
          <xsl:when test="position() mod 2 = 1">odd</xsl:when>
          <xsl:otherwise>even</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <td>
        <xsl:value-of select="n:CustomerID" />
      </td>
      <td>
        <xsl:value-of select="n:CompanyName" />
      </td>
      <td>
        <xsl:value-of select="n:ContactName" />
      </td>
      <td>
        <xsl:value-of select="n:ContactTitle" />
      </td>
      <td>
        <xsl:value-of select="n:Address" />
      </td>
      <td>
        <xsl:value-of select="n:City" />
      </td>
      <td>
        <xsl:value-of select="n:PostalCode" />
      </td>
      <td>
        <xsl:value-of select="n:Country" />
      </td>
      <td>
        <xsl:value-of select="n:Phone" />
      </td>
      <td>
        <xsl:value-of select="n:Fax" />
      </td>
    </tr>
  </xsl:template>

</xsl:stylesheet>