//-----------------------------------------------------------------------
//  This file is part of the Microsoft Robotics Studio Code Samples.
// 
//  Copyright (C) Microsoft Corporation.  All rights reserved.
//
//  $File: Direction.cs $ $Revision: 1 $
//-----------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using winforms = System.Windows.Forms;

namespace Microsoft.Robotics.Services.Sample.DirectionDialog
{
    public partial class Direction : Form
    {
        DirectionDialogOperations _mainPort;

        public Direction(DirectionDialogOperations mainPort)
        {
            _mainPort = mainPort;

            InitializeComponent();
        }

        private void button_MouseDown(object sender, MouseEventArgs e)
        {
            if (sender is winforms.Button)
            {
                winforms.Button button = (winforms.Button)sender;
                if (button.Name.StartsWith("btn"))
                {
                    string name = button.Name.Substring(3);

                    _mainPort.Post(new ButtonPress(new ButtonPressRequest(name)));
                }
            }
        }

        private void button_MouseUp(object sender, MouseEventArgs e)
        {
            if (sender is winforms.Button)
            {
                winforms.Button button = (winforms.Button)sender;
                if (button.Name.StartsWith("btn"))
                {
                    string name = button.Name.Substring(3);

                    _mainPort.Post(new ButtonRelease(new ButtonReleaseRequest(name)));
                }
            }
        }
    }
}