//-----------------------------------------------------------------------
//  This file is part of the Microsoft Robotics Studio Code Samples.
// 
//  Copyright (C) Microsoft Corporation.  All rights reserved.
//
//  $File: AlertForm.cs $ $Revision: 1 $
//-----------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Ccr.Core;

namespace Microsoft.Robotics.Services.Sample.Dialog
{
    public partial class AlertForm : Form
    {
        private SuccessFailurePort _result;

        public SuccessFailurePort Result
        {
            get { return _result; }
        }

        public string Message
        {
            get { return lblMessage.Text; }
            set { lblMessage.Text = value; }
        }


        public AlertForm()
            :this(new SuccessFailurePort())
        {
        }
	
        public AlertForm(SuccessFailurePort result)
        {
            _result = result;

            InitializeComponent();
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            _result.Post(new SuccessResult());
            Close();
        }
    }
}