//-----------------------------------------------------------------------
//  This file is part of the Microsoft Robotics Studio Code Samples.
// 
//  Copyright (C) Microsoft Corporation.  All rights reserved.
//
//  $File: UrlLauncherTypes.cs $ $Revision: 1 $
//-----------------------------------------------------------------------
#if !URT_MINCLR
using Microsoft.Ccr.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;

using System;
using System.Collections.Generic;
using System.ComponentModel;
using W3C.Soap;


namespace Microsoft.Robotics.Services.Sample.UrlLauncher
{
    /// Timer Contract
    public static class Contract
    {
        /// The Unique Contract Identifier for the Timer service
        public const string Identifier = "http://schemas.microsoft.com/robotics/2006/10/urllauncher.html";
    }

    [ServicePort]
    public class UrlLauncherOperations : PortSet<DsspDefaultLookup, DsspDefaultDrop, LaunchUrl>
    {
    }

    [DisplayName("LaunchURL")]
    [Description("Display for a browser window for the specified URL.")]
    public class LaunchUrl : Submit<LaunchUrlRequest, PortSet<DefaultSubmitResponseType, Fault>>
    {
    }

    [DataContract]
    public class LaunchUrlRequest
    {
        private string _url;
        [DataMember]
        [Description("Specifies the URL to open.")]
        public string Url
        {
            get { return _url; }
            set { _url = value; }
        }
	
    }
}
#endif