//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:2.0.50727.832
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using Microsoft.Ccr.Core;
using Microsoft.Dss.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Xml.Serialization;
using W3C.Soap;
using compression = System.IO.Compression;
using constructor = Microsoft.Dss.Services.Constructor;
using contractmanager = Microsoft.Dss.Services.ContractManager;
using contractmodel = Microsoft.Dss.Services.ContractModel;
using dssphttp = Microsoft.Dss.Core.DsspHttp;
using io = System.IO;
using pxxinputgamepad = Microsoft.Robotics.Services.Sample.XInputGamepad.Proxy;
using reflection = System.Reflection;


namespace Microsoft.Robotics.Services.Sample.XInputGamepad.Proxy
{
    
    
    /// <summary>
    /// XInputGamepad Contract
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public sealed class Contract
    {
        
        /// The Unique Contract Identifier for the XInputGamepad service
        public const String Identifier = "http://schemas.microsoft.com/robotics/2006/09/xinputgamepad.html";
        
        /// The Dss Service dssModel Contract(s)
        public static List<contractmodel.ServiceSummary> ServiceModel()
        {
            contractmanager.ServiceSummaryLoader loader = new contractmanager.ServiceSummaryLoader();
            return loader.GetServiceSummaries(typeof(Contract).Assembly);

        }
        
        /// <summary>
        /// Creates an instance of the service associated with this contract
        /// </summary>
        /// <param name="contructorServicePort">Contractor Service that will create the instance</param>
        /// <param name="partners">Optional list of service partners for new service instance</param>
        /// <returns>Result PortSet for retrieving service creation response</returns>
        public static DsspResponsePort<CreateResponse> CreateService(constructor.ConstructorPort contructorServicePort, params PartnerType[] partners)
        {
            DsspResponsePort<CreateResponse> result = new DsspResponsePort<CreateResponse>();
            ServiceInfoType si = new ServiceInfoType(Contract.Identifier, null);
            if (partners != null)
            {
                si.PartnerList = new List<PartnerType>(partners);
            }
            Microsoft.Dss.Services.Constructor.Create create =
                new Microsoft.Dss.Services.Constructor.Create(si, result);
            contructorServicePort.Post(create);
            return result;

        }
        
        /// <summary>
        /// Creates an instance of the service associated with this contract
        /// </summary>
        /// <param name="contructorServicePort">Contractor Service that will create the instance</param>
        /// <returns>Result PortSet for retrieving service creation response</returns>
        public static DsspResponsePort<CreateResponse> CreateService(constructor.ConstructorPort contructorServicePort)
        {
            return Contract.CreateService(contructorServicePort, null);
        }
    }
    
    /// <summary>
    /// Specifies the state of the X Input controller.
    /// </summary>
    [Description("Specifies the state of the XInput controller.")]
    [DataContract()]
    [XmlRootAttribute("XInputGamepadState", Namespace="http://schemas.microsoft.com/robotics/2006/09/xinputgamepad.html")]
    public class XInputGamepadState : ICloneable, IDssSerializable
    {
        
        private DateTime _timeStamp;
        
        private Controller _controller = new Controller();
        
        private DPad _dPad = new DPad();
        
        private Buttons _buttons = new Buttons();
        
        private Triggers _triggers = new Triggers();
        
        private Thumbsticks _thumbsticks = new Thumbsticks();
        
        private Vibration _vibration = new Vibration();
        
        /// <summary>
        /// Time Stamp
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Indicates time of the controller\'s state update.")]
        public DateTime TimeStamp
        {
            get
            {
                return this._timeStamp;
            }
            set
            {
                this._timeStamp = value;
            }
        }
        
        /// <summary>
        /// Controller
        /// </summary>
        [DataMember(IsRequired=true)]
        [Description("Indicates controller state.")]
        public Controller Controller
        {
            get
            {
                return this._controller;
            }
            set
            {
                this._controller = value;
            }
        }
        
        /// <summary>
        /// D Pad
        /// </summary>
        [DataMember(IsRequired=true)]
        [Browsable(false)]
        [Description("Indicates the state of the directional pad.")]
        public DPad DPad
        {
            get
            {
                return this._dPad;
            }
            set
            {
                this._dPad = value;
            }
        }
        
        /// <summary>
        /// Buttons
        /// </summary>
        [DataMember(IsRequired=true)]
        [Browsable(false)]
        [Description("Identifies the state of the buttons.")]
        public Buttons Buttons
        {
            get
            {
                return this._buttons;
            }
            set
            {
                this._buttons = value;
            }
        }
        
        /// <summary>
        /// Triggers
        /// </summary>
        [DataMember(IsRequired=true)]
        [Browsable(false)]
        [Description("Identifies the state of the triggers.")]
        public Triggers Triggers
        {
            get
            {
                return this._triggers;
            }
            set
            {
                this._triggers = value;
            }
        }
        
        /// <summary>
        /// Thumbsticks
        /// </summary>
        [DataMember(IsRequired=true)]
        [Browsable(false)]
        [Description("Identifies the state of the thumbsticks.")]
        public Thumbsticks Thumbsticks
        {
            get
            {
                return this._thumbsticks;
            }
            set
            {
                this._thumbsticks = value;
            }
        }
        
        /// <summary>
        /// Vibration
        /// </summary>
        [DataMember(IsRequired=true)]
        [Browsable(false)]
        [Description("Identifies the state of the vibration motors.")]
        public Vibration Vibration
        {
            get
            {
                return this._vibration;
            }
            set
            {
                this._vibration = value;
            }
        }
        
        /// <summary>
        /// Copy To X Input Gamepad State
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            XInputGamepadState typedTarget = target as XInputGamepadState;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.TimeStamp = this.TimeStamp;
            typedTarget.Controller = (this.Controller == null) ? null : (Controller)((Microsoft.Dss.Core.IDssSerializable)this.Controller).Clone();
            typedTarget.DPad = (this.DPad == null) ? null : (DPad)((Microsoft.Dss.Core.IDssSerializable)this.DPad).Clone();
            typedTarget.Buttons = (this.Buttons == null) ? null : (Buttons)((Microsoft.Dss.Core.IDssSerializable)this.Buttons).Clone();
            typedTarget.Triggers = (this.Triggers == null) ? null : (Triggers)((Microsoft.Dss.Core.IDssSerializable)this.Triggers).Clone();
            typedTarget.Thumbsticks = (this.Thumbsticks == null) ? null : (Thumbsticks)((Microsoft.Dss.Core.IDssSerializable)this.Thumbsticks).Clone();
            typedTarget.Vibration = (this.Vibration == null) ? null : (Vibration)((Microsoft.Dss.Core.IDssSerializable)this.Vibration).Clone();
        }
        
        /// <summary>
        /// Clone X Input Gamepad State
        /// </summary>
        public virtual object Clone()
        {
            XInputGamepadState target = new XInputGamepadState();

            target.TimeStamp = this.TimeStamp;
            target.Controller = (this.Controller == null) ? null : (Controller)((Microsoft.Dss.Core.IDssSerializable)this.Controller).Clone();
            target.DPad = (this.DPad == null) ? null : (DPad)((Microsoft.Dss.Core.IDssSerializable)this.DPad).Clone();
            target.Buttons = (this.Buttons == null) ? null : (Buttons)((Microsoft.Dss.Core.IDssSerializable)this.Buttons).Clone();
            target.Triggers = (this.Triggers == null) ? null : (Triggers)((Microsoft.Dss.Core.IDssSerializable)this.Triggers).Clone();
            target.Thumbsticks = (this.Thumbsticks == null) ? null : (Thumbsticks)((Microsoft.Dss.Core.IDssSerializable)this.Thumbsticks).Clone();
            target.Vibration = (this.Vibration == null) ? null : (Vibration)((Microsoft.Dss.Core.IDssSerializable)this.Vibration).Clone();
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            Microsoft.Dss.Services.Serializer.BinarySerializationHelper.SerializeDateTime(TimeStamp, writer);

            if (Controller == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                ((Microsoft.Dss.Core.IDssSerializable)Controller).Serialize(writer);
            }

            if (DPad == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                ((Microsoft.Dss.Core.IDssSerializable)DPad).Serialize(writer);
            }

            if (Buttons == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                ((Microsoft.Dss.Core.IDssSerializable)Buttons).Serialize(writer);
            }

            if (Triggers == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                ((Microsoft.Dss.Core.IDssSerializable)Triggers).Serialize(writer);
            }

            if (Thumbsticks == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                ((Microsoft.Dss.Core.IDssSerializable)Thumbsticks).Serialize(writer);
            }

            if (Vibration == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                ((Microsoft.Dss.Core.IDssSerializable)Vibration).Serialize(writer);
            }

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            TimeStamp = Microsoft.Dss.Services.Serializer.BinarySerializationHelper.DeserializeDateTime(reader);

            if (reader.ReadByte() == 0) {}
            else
            {
                Controller = (Controller)((Microsoft.Dss.Core.IDssSerializable)new Controller()).Deserialize(reader);
            } //nullable

            if (reader.ReadByte() == 0) {}
            else
            {
                DPad = (DPad)((Microsoft.Dss.Core.IDssSerializable)new DPad()).Deserialize(reader);
            } //nullable

            if (reader.ReadByte() == 0) {}
            else
            {
                Buttons = (Buttons)((Microsoft.Dss.Core.IDssSerializable)new Buttons()).Deserialize(reader);
            } //nullable

            if (reader.ReadByte() == 0) {}
            else
            {
                Triggers = (Triggers)((Microsoft.Dss.Core.IDssSerializable)new Triggers()).Deserialize(reader);
            } //nullable

            if (reader.ReadByte() == 0) {}
            else
            {
                Thumbsticks = (Thumbsticks)((Microsoft.Dss.Core.IDssSerializable)new Thumbsticks()).Deserialize(reader);
            } //nullable

            if (reader.ReadByte() == 0) {}
            else
            {
                Vibration = (Vibration)((Microsoft.Dss.Core.IDssSerializable)new Vibration()).Deserialize(reader);
            } //nullable

            return this;

        }
    }
    
    /// <summary>
    /// Poll Request
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("PollRequest", Namespace="http://schemas.microsoft.com/robotics/2006/09/xinputgamepad.html")]
    public class PollRequest : ICloneable, IDssSerializable
    {
        
        /// <summary>
        /// Copy To Poll Request
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            PollRequest typedTarget = target as PollRequest;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
        }
        
        /// <summary>
        /// Clone Poll Request
        /// </summary>
        public virtual object Clone()
        {
            // For a class without fields, cloning isn't necessary
            return this;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            return this;

        }
    }
    
    /// <summary>
    /// Identifies the state of the directional pad.
    /// </summary>
    [Description("Identifies the state of the directional pad.")]
    [DataContract()]
    [XmlRootAttribute("DPad", Namespace="http://schemas.microsoft.com/robotics/2006/09/xinputgamepad.html")]
    public class DPad : ICloneable, IDssSerializable
    {
        
        private DateTime _timeStamp;
        
        private Boolean _left;
        
        private Boolean _down;
        
        private Boolean _right;
        
        private Boolean _up;
        
        /// <summary>
        /// Time Stamp
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies the time of the directional pad input.")]
        public DateTime TimeStamp
        {
            get
            {
                return this._timeStamp;
            }
            set
            {
                this._timeStamp = value;
            }
        }
        
        /// <summary>
        /// Left
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Indicates if the directional pad is pressed left.")]
        public Boolean Left
        {
            get
            {
                return this._left;
            }
            set
            {
                this._left = value;
            }
        }
        
        /// <summary>
        /// Down
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Indicates if the directional pad is pressed down.")]
        public Boolean Down
        {
            get
            {
                return this._down;
            }
            set
            {
                this._down = value;
            }
        }
        
        /// <summary>
        /// Right
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Indicates if the directional pad is pressed right.")]
        public Boolean Right
        {
            get
            {
                return this._right;
            }
            set
            {
                this._right = value;
            }
        }
        
        /// <summary>
        /// Up
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Indicates if the directional pad is pressed up.")]
        public Boolean Up
        {
            get
            {
                return this._up;
            }
            set
            {
                this._up = value;
            }
        }
        
        /// <summary>
        /// Copy To D Pad
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            DPad typedTarget = target as DPad;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.TimeStamp = this.TimeStamp;
            typedTarget.Left = this.Left;
            typedTarget.Down = this.Down;
            typedTarget.Right = this.Right;
            typedTarget.Up = this.Up;
        }
        
        /// <summary>
        /// Clone D Pad
        /// </summary>
        public virtual object Clone()
        {
            DPad target = new DPad();

            target.TimeStamp = this.TimeStamp;
            target.Left = this.Left;
            target.Down = this.Down;
            target.Right = this.Right;
            target.Up = this.Up;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            Microsoft.Dss.Services.Serializer.BinarySerializationHelper.SerializeDateTime(TimeStamp, writer);

            writer.Write(Left);

            writer.Write(Down);

            writer.Write(Right);

            writer.Write(Up);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            TimeStamp = Microsoft.Dss.Services.Serializer.BinarySerializationHelper.DeserializeDateTime(reader);

            Left = reader.ReadBoolean();

            Down = reader.ReadBoolean();

            Right = reader.ReadBoolean();

            Up = reader.ReadBoolean();

            return this;

        }
    }
    
    /// <summary>
    /// Identifies the state of the controller buttons.
    /// </summary>
    [Description("Identifies the state of the controller buttons.")]
    [DataContract()]
    [XmlRootAttribute("Buttons", Namespace="http://schemas.microsoft.com/robotics/2006/09/xinputgamepad.html")]
    public class Buttons : ICloneable, IDssSerializable
    {
        
        private DateTime _timeStamp;
        
        private Boolean _a;
        
        private Boolean _b;
        
        private Boolean _x;
        
        private Boolean _y;
        
        private Boolean _back;
        
        private Boolean _start;
        
        private Boolean _leftStick;
        
        private Boolean _rightStick;
        
        private Boolean _leftShoulder;
        
        private Boolean _rightShoulder;
        
        /// <summary>
        /// Time Stamp
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies the time of the button input.")]
        public DateTime TimeStamp
        {
            get
            {
                return this._timeStamp;
            }
            set
            {
                this._timeStamp = value;
            }
        }
        
        /// <summary>
        /// A
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies whether the A button was pressed.")]
        public Boolean A
        {
            get
            {
                return this._a;
            }
            set
            {
                this._a = value;
            }
        }
        
        /// <summary>
        /// B
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies whether the B button was pressed.")]
        public Boolean B
        {
            get
            {
                return this._b;
            }
            set
            {
                this._b = value;
            }
        }
        
        /// <summary>
        /// X
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies whether the X button was pressed.")]
        public Boolean X
        {
            get
            {
                return this._x;
            }
            set
            {
                this._x = value;
            }
        }
        
        /// <summary>
        /// Y
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies whether the Y button was pressed.")]
        public Boolean Y
        {
            get
            {
                return this._y;
            }
            set
            {
                this._y = value;
            }
        }
        
        /// <summary>
        /// Back
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies whether the Back button was pressed.")]
        public Boolean Back
        {
            get
            {
                return this._back;
            }
            set
            {
                this._back = value;
            }
        }
        
        /// <summary>
        /// Start
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies whether the Start button was pressed.")]
        public Boolean Start
        {
            get
            {
                return this._start;
            }
            set
            {
                this._start = value;
            }
        }
        
        /// <summary>
        /// Left Stick
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies whether the left thumbstick was pressed.")]
        public Boolean LeftStick
        {
            get
            {
                return this._leftStick;
            }
            set
            {
                this._leftStick = value;
            }
        }
        
        /// <summary>
        /// Right Stick
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies whether the right thumbstick was pressed.")]
        public Boolean RightStick
        {
            get
            {
                return this._rightStick;
            }
            set
            {
                this._rightStick = value;
            }
        }
        
        /// <summary>
        /// Left Shoulder
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies whether the left shoulder (bumper) was pressed.")]
        public Boolean LeftShoulder
        {
            get
            {
                return this._leftShoulder;
            }
            set
            {
                this._leftShoulder = value;
            }
        }
        
        /// <summary>
        /// Right Shoulder
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies whether the right shoulder (bumper) was pressed.")]
        public Boolean RightShoulder
        {
            get
            {
                return this._rightShoulder;
            }
            set
            {
                this._rightShoulder = value;
            }
        }
        
        /// <summary>
        /// Copy To Buttons
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            Buttons typedTarget = target as Buttons;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.TimeStamp = this.TimeStamp;
            typedTarget.A = this.A;
            typedTarget.B = this.B;
            typedTarget.X = this.X;
            typedTarget.Y = this.Y;
            typedTarget.Back = this.Back;
            typedTarget.Start = this.Start;
            typedTarget.LeftStick = this.LeftStick;
            typedTarget.RightStick = this.RightStick;
            typedTarget.LeftShoulder = this.LeftShoulder;
            typedTarget.RightShoulder = this.RightShoulder;
        }
        
        /// <summary>
        /// Clone Buttons
        /// </summary>
        public virtual object Clone()
        {
            Buttons target = new Buttons();

            target.TimeStamp = this.TimeStamp;
            target.A = this.A;
            target.B = this.B;
            target.X = this.X;
            target.Y = this.Y;
            target.Back = this.Back;
            target.Start = this.Start;
            target.LeftStick = this.LeftStick;
            target.RightStick = this.RightStick;
            target.LeftShoulder = this.LeftShoulder;
            target.RightShoulder = this.RightShoulder;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            Microsoft.Dss.Services.Serializer.BinarySerializationHelper.SerializeDateTime(TimeStamp, writer);

            writer.Write(A);

            writer.Write(B);

            writer.Write(X);

            writer.Write(Y);

            writer.Write(Back);

            writer.Write(Start);

            writer.Write(LeftStick);

            writer.Write(RightStick);

            writer.Write(LeftShoulder);

            writer.Write(RightShoulder);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            TimeStamp = Microsoft.Dss.Services.Serializer.BinarySerializationHelper.DeserializeDateTime(reader);

            A = reader.ReadBoolean();

            B = reader.ReadBoolean();

            X = reader.ReadBoolean();

            Y = reader.ReadBoolean();

            Back = reader.ReadBoolean();

            Start = reader.ReadBoolean();

            LeftStick = reader.ReadBoolean();

            RightStick = reader.ReadBoolean();

            LeftShoulder = reader.ReadBoolean();

            RightShoulder = reader.ReadBoolean();

            return this;

        }
    }
    
    /// <summary>
    /// Identifies the state of the controller 's triggers.
    /// </summary>
    [Description("Identifies the state of the controller\'s triggers.")]
    [DataContract()]
    [XmlRootAttribute("Triggers", Namespace="http://schemas.microsoft.com/robotics/2006/09/xinputgamepad.html")]
    public class Triggers : ICloneable, IDssSerializable
    {
        
        private DateTime _timeStamp;
        
        private Single _left;
        
        private Single _right;
        
        /// <summary>
        /// Time Stamp
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies the time of the trigger input.")]
        public DateTime TimeStamp
        {
            get
            {
                return this._timeStamp;
            }
            set
            {
                this._timeStamp = value;
            }
        }
        
        /// <summary>
        /// Left
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies the left trigger value.")]
        public Single Left
        {
            get
            {
                return this._left;
            }
            set
            {
                this._left = value;
            }
        }
        
        /// <summary>
        /// Right
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies the right trigger value.")]
        public Single Right
        {
            get
            {
                return this._right;
            }
            set
            {
                this._right = value;
            }
        }
        
        /// <summary>
        /// Copy To Triggers
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            Triggers typedTarget = target as Triggers;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.TimeStamp = this.TimeStamp;
            typedTarget.Left = this.Left;
            typedTarget.Right = this.Right;
        }
        
        /// <summary>
        /// Clone Triggers
        /// </summary>
        public virtual object Clone()
        {
            Triggers target = new Triggers();

            target.TimeStamp = this.TimeStamp;
            target.Left = this.Left;
            target.Right = this.Right;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            Microsoft.Dss.Services.Serializer.BinarySerializationHelper.SerializeDateTime(TimeStamp, writer);

            writer.Write(Left);

            writer.Write(Right);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            TimeStamp = Microsoft.Dss.Services.Serializer.BinarySerializationHelper.DeserializeDateTime(reader);

            Left = reader.ReadSingle();

            Right = reader.ReadSingle();

            return this;

        }
    }
    
    /// <summary>
    /// Identifies the thumbsticks state.
    /// </summary>
    [Description("Identifies the thumbsticks state.")]
    [DataContract()]
    [XmlRootAttribute("Thumbsticks", Namespace="http://schemas.microsoft.com/robotics/2006/09/xinputgamepad.html")]
    public class Thumbsticks : ICloneable, IDssSerializable
    {
        
        private DateTime _timeStamp;
        
        private Single _leftX;
        
        private Single _leftY;
        
        private Single _rightX;
        
        private Single _rightY;
        
        /// <summary>
        /// Time Stamp
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies the time of the thumbstick input.")]
        public DateTime TimeStamp
        {
            get
            {
                return this._timeStamp;
            }
            set
            {
                this._timeStamp = value;
            }
        }
        
        /// <summary>
        /// LeftX
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies the X value of left thumbstick.")]
        public Single LeftX
        {
            get
            {
                return this._leftX;
            }
            set
            {
                this._leftX = value;
            }
        }
        
        /// <summary>
        /// LeftY
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies the Y value of left thumbstick.")]
        public Single LeftY
        {
            get
            {
                return this._leftY;
            }
            set
            {
                this._leftY = value;
            }
        }
        
        /// <summary>
        /// RightX
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies the X value of right thumbstick.")]
        public Single RightX
        {
            get
            {
                return this._rightX;
            }
            set
            {
                this._rightX = value;
            }
        }
        
        /// <summary>
        /// RightY
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies the Y value of right thumbstick.")]
        public Single RightY
        {
            get
            {
                return this._rightY;
            }
            set
            {
                this._rightY = value;
            }
        }
        
        /// <summary>
        /// Copy To Thumbsticks
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            Thumbsticks typedTarget = target as Thumbsticks;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.TimeStamp = this.TimeStamp;
            typedTarget.LeftX = this.LeftX;
            typedTarget.LeftY = this.LeftY;
            typedTarget.RightX = this.RightX;
            typedTarget.RightY = this.RightY;
        }
        
        /// <summary>
        /// Clone Thumbsticks
        /// </summary>
        public virtual object Clone()
        {
            Thumbsticks target = new Thumbsticks();

            target.TimeStamp = this.TimeStamp;
            target.LeftX = this.LeftX;
            target.LeftY = this.LeftY;
            target.RightX = this.RightX;
            target.RightY = this.RightY;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            Microsoft.Dss.Services.Serializer.BinarySerializationHelper.SerializeDateTime(TimeStamp, writer);

            writer.Write(LeftX);

            writer.Write(LeftY);

            writer.Write(RightX);

            writer.Write(RightY);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            TimeStamp = Microsoft.Dss.Services.Serializer.BinarySerializationHelper.DeserializeDateTime(reader);

            LeftX = reader.ReadSingle();

            LeftY = reader.ReadSingle();

            RightX = reader.ReadSingle();

            RightY = reader.ReadSingle();

            return this;

        }
    }
    
    /// <summary>
    /// Controller
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("Controller", Namespace="http://schemas.microsoft.com/robotics/2006/09/xinputgamepad.html")]
    public class Controller : ICloneable, IDssSerializable
    {
        
        private DateTime _timeStamp;
        
        private PlayerIndex _playerIndex;
        
        private Boolean _isConnected;
        
        /// <summary>
        /// Time Stamp
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Indicates the time of the controller change.")]
        public DateTime TimeStamp
        {
            get
            {
                return this._timeStamp;
            }
            set
            {
                this._timeStamp = value;
            }
        }
        
        /// <summary>
        /// Player Index
        /// </summary>
        [DataMember()]
        [Description("Identifies the player index.")]
        public PlayerIndex PlayerIndex
        {
            get
            {
                return this._playerIndex;
            }
            set
            {
                this._playerIndex = value;
            }
        }
        
        /// <summary>
        /// Is Connected
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Indicates whether a controller is connected.")]
        public Boolean IsConnected
        {
            get
            {
                return this._isConnected;
            }
            set
            {
                this._isConnected = value;
            }
        }
        
        /// <summary>
        /// Copy To Controller
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            Controller typedTarget = target as Controller;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.TimeStamp = this.TimeStamp;
            typedTarget.PlayerIndex = this.PlayerIndex;
            typedTarget.IsConnected = this.IsConnected;
        }
        
        /// <summary>
        /// Clone Controller
        /// </summary>
        public virtual object Clone()
        {
            Controller target = new Controller();

            target.TimeStamp = this.TimeStamp;
            target.PlayerIndex = this.PlayerIndex;
            target.IsConnected = this.IsConnected;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            Microsoft.Dss.Services.Serializer.BinarySerializationHelper.SerializeDateTime(TimeStamp, writer);

            writer.Write((System.Int32)PlayerIndex);

            writer.Write(IsConnected);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            TimeStamp = Microsoft.Dss.Services.Serializer.BinarySerializationHelper.DeserializeDateTime(reader);

            PlayerIndex = (PlayerIndex)reader.ReadInt32();

            IsConnected = reader.ReadBoolean();

            return this;

        }
    }
    
    /// <summary>
    /// Identifies the vibration motors' state.
    /// </summary>
    [Description("Identifies the vibration motors\' state.")]
    [DataContract()]
    [XmlRootAttribute("Vibration", Namespace="http://schemas.microsoft.com/robotics/2006/09/xinputgamepad.html")]
    public class Vibration : ICloneable, IDssSerializable
    {
        
        private DateTime _timeStamp;
        
        private Single _left;
        
        private Single _right;
        
        /// <summary>
        /// Time Stamp
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies the time of the vibration motors change.")]
        public DateTime TimeStamp
        {
            get
            {
                return this._timeStamp;
            }
            set
            {
                this._timeStamp = value;
            }
        }
        
        /// <summary>
        /// Left
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies the value of the left vibration motor.")]
        public Single Left
        {
            get
            {
                return this._left;
            }
            set
            {
                this._left = value;
            }
        }
        
        /// <summary>
        /// Right
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Identifies the value of the right vibration motor.")]
        public Single Right
        {
            get
            {
                return this._right;
            }
            set
            {
                this._right = value;
            }
        }
        
        /// <summary>
        /// Copy To Vibration
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            Vibration typedTarget = target as Vibration;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.TimeStamp = this.TimeStamp;
            typedTarget.Left = this.Left;
            typedTarget.Right = this.Right;
        }
        
        /// <summary>
        /// Clone Vibration
        /// </summary>
        public virtual object Clone()
        {
            Vibration target = new Vibration();

            target.TimeStamp = this.TimeStamp;
            target.Left = this.Left;
            target.Right = this.Right;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            Microsoft.Dss.Services.Serializer.BinarySerializationHelper.SerializeDateTime(TimeStamp, writer);

            writer.Write(Left);

            writer.Write(Right);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            TimeStamp = Microsoft.Dss.Services.Serializer.BinarySerializationHelper.DeserializeDateTime(reader);

            Left = reader.ReadSingle();

            Right = reader.ReadSingle();

            return this;

        }
    }
    
    /// <summary>
    /// Query Controllers Request
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("QueryControllersRequest", Namespace="http://schemas.microsoft.com/robotics/2006/09/xinputgamepad.html")]
    public class QueryControllersRequest : ICloneable, IDssSerializable
    {
        
        /// <summary>
        /// Copy To Query Controllers Request
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            QueryControllersRequest typedTarget = target as QueryControllersRequest;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
        }
        
        /// <summary>
        /// Clone Query Controllers Request
        /// </summary>
        public virtual object Clone()
        {
            // For a class without fields, cloning isn't necessary
            return this;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            return this;

        }
    }
    
    /// <summary>
    /// Query Controllers Response
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("QueryControllersResponse", Namespace="http://schemas.microsoft.com/robotics/2006/09/xinputgamepad.html")]
    public class QueryControllersResponse : ICloneable, IDssSerializable
    {
        
        private List<ControllerCaps> _controllers = new List<ControllerCaps>();
        
        /// <summary>
        /// Controllers
        /// </summary>
        [DataMember(IsRequired=true)]
        public List<ControllerCaps> Controllers
        {
            get
            {
                return this._controllers;
            }
            set
            {
                this._controllers = value;
            }
        }
        
        /// <summary>
        /// Copy To Query Controllers Response
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            QueryControllersResponse typedTarget = target as QueryControllersResponse;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);

            // copy IEnumerable System.Collections.Generic.List<ControllerCaps> Controllers
            if (this.Controllers != null)
            {
                typedTarget.Controllers = new System.Collections.Generic.List<ControllerCaps>();
                foreach(ControllerCaps elem in Controllers)
                {
                    typedTarget.Controllers.Add((elem == null) ? null : (ControllerCaps)((Microsoft.Dss.Core.IDssSerializable)elem).Clone());
                }
            }
        }
        
        /// <summary>
        /// Clone Query Controllers Response
        /// </summary>
        public virtual object Clone()
        {
            QueryControllersResponse target = new QueryControllersResponse();


            // copy IEnumerable System.Collections.Generic.List<ControllerCaps> Controllers
            if (this.Controllers != null)
            {
                target.Controllers = new System.Collections.Generic.List<ControllerCaps>();
                foreach(ControllerCaps elem in Controllers)
                {
                    target.Controllers.Add((elem == null) ? null : (ControllerCaps)((Microsoft.Dss.Core.IDssSerializable)elem).Clone());
                }
            }
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            if (Controllers == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(this.Controllers.Count);
                for(int index1459644758 = 0; index1459644758 < this.Controllers.Count; index1459644758++)
                {
                    if (Controllers[index1459644758] == null) writer.Write((byte)0);
                    else
                    {
                        // null flag
                        writer.Write((byte)1);

                        ((Microsoft.Dss.Core.IDssSerializable)Controllers[index1459644758]).Serialize(writer);
                    }
                }
            }

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            if (reader.ReadByte() == 0) {}
            else
            {
                int count2835322538 = reader.ReadInt32();
                Controllers = new System.Collections.Generic.List<ControllerCaps>();
                for(int index1459644758 = 0; index1459644758< count2835322538; index1459644758++)
                {
                    Controllers.Add(null);
                    if (reader.ReadByte() == 0) {}
                    else
                    {
                        Controllers[index1459644758] = (ControllerCaps)((Microsoft.Dss.Core.IDssSerializable)new ControllerCaps()).Deserialize(reader);
                    } //nullable
                }
            } //nullable

            return this;

        }
    }
    
    /// <summary>
    /// Identifies the player index.
    /// </summary>
    [Description("Identifies the player index.")]
    [DataContract()]
    [XmlRootAttribute("PlayerIndex", Namespace="http://schemas.microsoft.com/robotics/2006/09/xinputgamepad.html")]
    public enum PlayerIndex
    {
        
        /// <summary>
        /// One
        /// </summary>
        One = 0,
        
        /// <summary>
        /// Two
        /// </summary>
        Two = 1,
        
        /// <summary>
        /// Three
        /// </summary>
        Three = 2,
        
        /// <summary>
        /// Four
        /// </summary>
        Four = 3,
        
        /// <summary>
        /// Any
        /// </summary>
        Any = 255,
    }
    
    /// <summary>
    /// Identifies the controller type.
    /// </summary>
    [Description("Identifies the controller type.")]
    [DataContract()]
    [XmlRootAttribute("ControllerType", Namespace="http://schemas.microsoft.com/robotics/2006/09/xinputgamepad.html")]
    public enum ControllerType
    {
        
        /// <summary>
        /// Not Selected
        /// </summary>
        NotSelected = 0,
        
        /// <summary>
        /// Game Pad
        /// </summary>
        GamePad = 1,
        
        /// <summary>
        /// Wheel
        /// </summary>
        Wheel = 2,
        
        /// <summary>
        /// Arcade Stick
        /// </summary>
        ArcadeStick = 3,
        
        /// <summary>
        /// Flight Stick
        /// </summary>
        FlightStick = 4,
        
        /// <summary>
        /// Dance Pad
        /// </summary>
        DancePad = 5,
    }
    
    /// <summary>
    /// Controller Caps
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("ControllerCaps", Namespace="http://schemas.microsoft.com/robotics/2006/09/xinputgamepad.html")]
    public class ControllerCaps : Controller
    {
        
        private ControllerType _controllerType;
        
        /// <summary>
        /// Controller Type
        /// </summary>
        [DataMember()]
        public ControllerType ControllerType
        {
            get
            {
                return this._controllerType;
            }
            set
            {
                this._controllerType = value;
            }
        }
        
        /// <summary>
        /// Copy To Controller Caps
        /// </summary>
        public override void CopyTo(IDssSerializable target)
        {
            ControllerCaps typedTarget = target as ControllerCaps;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            base.CopyTo(typedTarget);
            typedTarget.ControllerType = this.ControllerType;
        }
        
        /// <summary>
        /// Clone Controller Caps
        /// </summary>
        public override object Clone()
        {
            ControllerCaps target = new ControllerCaps();

            base.CopyTo(target);
            target.ControllerType = this.ControllerType;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public override void Serialize(System.IO.BinaryWriter writer)
        {
            base.Serialize(writer);
            writer.Write((System.Int32)ControllerType);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public override object Deserialize(System.IO.BinaryReader reader)
        {
            base.Deserialize(reader);
            ControllerType = (ControllerType)reader.ReadInt32();

            return this;

        }
    }
    
    /// <summary>
    /// X Input Gamepad Operations
    /// </summary>
    [ServicePort()]
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class XInputGamepadOperations : PortSet<Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup, Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop, Subscribe, Get, dssphttp.HttpGet, Replace, Poll, DPadChanged, ButtonsChanged, TriggersChanged, ThumbsticksChanged, ControllerChanged, SetVibration, QueryControllers>
    {
        
        /// <summary>
        /// Required Lookup request body type
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.LookupResponse,Fault> DsspDefaultLookup()
        {
            Microsoft.Dss.ServiceModel.Dssp.LookupRequestType body = new Microsoft.Dss.ServiceModel.Dssp.LookupRequestType();
            Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup op = new Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Dssp Default Lookup and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.LookupResponse,Fault> DsspDefaultLookup(Microsoft.Dss.ServiceModel.Dssp.LookupRequestType body)
        {
            Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup op = new Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup();
            op.Body = body ?? new Microsoft.Dss.ServiceModel.Dssp.LookupRequestType();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// A request to drop the service.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultDropResponseType,Fault> DsspDefaultDrop()
        {
            Microsoft.Dss.ServiceModel.Dssp.DropRequestType body = new Microsoft.Dss.ServiceModel.Dssp.DropRequestType();
            Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop op = new Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Dssp Default Drop and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultDropResponseType,Fault> DsspDefaultDrop(Microsoft.Dss.ServiceModel.Dssp.DropRequestType body)
        {
            Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop op = new Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop();
            op.Body = body ?? new Microsoft.Dss.ServiceModel.Dssp.DropRequestType();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Subscribe and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.SubscribeResponseType,Fault> Subscribe(IPort notificationPort)
        {
            Subscribe op = new Subscribe();
            op.Body = new Microsoft.Dss.ServiceModel.Dssp.SubscribeRequestType();
            op.NotificationPort = notificationPort;
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Subscribe and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.SubscribeResponseType,Fault> Subscribe(Microsoft.Dss.ServiceModel.Dssp.SubscribeRequestType body, IPort notificationPort)
        {
            Subscribe op = new Subscribe();
            op.Body = body ?? new Microsoft.Dss.ServiceModel.Dssp.SubscribeRequestType();
            op.NotificationPort = notificationPort;
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Required Get body type
        /// </summary>
        public virtual PortSet<XInputGamepadState,Fault> Get()
        {
            Microsoft.Dss.ServiceModel.Dssp.GetRequestType body = new Microsoft.Dss.ServiceModel.Dssp.GetRequestType();
            Get op = new Get(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Get and return the response port.
        /// </summary>
        public virtual PortSet<XInputGamepadState,Fault> Get(Microsoft.Dss.ServiceModel.Dssp.GetRequestType body)
        {
            Get op = new Get();
            op.Body = body ?? new Microsoft.Dss.ServiceModel.Dssp.GetRequestType();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// DsspHttp Get request body
        /// </summary>
        public virtual PortSet<dssphttp.HttpResponseType,Fault> HttpGet()
        {
            dssphttp.HttpGetRequestType body = new dssphttp.HttpGetRequestType();
            dssphttp.HttpGet op = new dssphttp.HttpGet(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Http Get and return the response port.
        /// </summary>
        public virtual PortSet<dssphttp.HttpResponseType,Fault> HttpGet(dssphttp.HttpGetRequestType body)
        {
            dssphttp.HttpGet op = new dssphttp.HttpGet();
            op.Body = body ?? new dssphttp.HttpGetRequestType();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Specifies the state of the X Input controller.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultReplaceResponseType,Fault> Replace()
        {
            XInputGamepadState body = new XInputGamepadState();
            Replace op = new Replace(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Replace and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultReplaceResponseType,Fault> Replace(XInputGamepadState body)
        {
            Replace op = new Replace();
            op.Body = body ?? new XInputGamepadState();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Poll Request
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultSubmitResponseType,Fault> Poll()
        {
            PollRequest body = new PollRequest();
            Poll op = new Poll(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Poll and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultSubmitResponseType,Fault> Poll(PollRequest body)
        {
            Poll op = new Poll();
            op.Body = body ?? new PollRequest();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Identifies the state of the directional pad.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> DPadChanged()
        {
            DPad body = new DPad();
            DPadChanged op = new DPadChanged(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post D Pad Changed and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> DPadChanged(DPad body)
        {
            DPadChanged op = new DPadChanged();
            op.Body = body ?? new DPad();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Identifies the state of the controller buttons.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> ButtonsChanged()
        {
            Buttons body = new Buttons();
            ButtonsChanged op = new ButtonsChanged(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Buttons Changed and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> ButtonsChanged(Buttons body)
        {
            ButtonsChanged op = new ButtonsChanged();
            op.Body = body ?? new Buttons();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Identifies the state of the controller 's triggers.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> TriggersChanged()
        {
            Triggers body = new Triggers();
            TriggersChanged op = new TriggersChanged(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Triggers Changed and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> TriggersChanged(Triggers body)
        {
            TriggersChanged op = new TriggersChanged();
            op.Body = body ?? new Triggers();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Identifies the thumbsticks state.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> ThumbsticksChanged()
        {
            Thumbsticks body = new Thumbsticks();
            ThumbsticksChanged op = new ThumbsticksChanged(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Thumbsticks Changed and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> ThumbsticksChanged(Thumbsticks body)
        {
            ThumbsticksChanged op = new ThumbsticksChanged();
            op.Body = body ?? new Thumbsticks();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Controller
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> ControllerChanged()
        {
            Controller body = new Controller();
            ControllerChanged op = new ControllerChanged(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Controller Changed and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> ControllerChanged(Controller body)
        {
            ControllerChanged op = new ControllerChanged();
            op.Body = body ?? new Controller();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Identifies the vibration motors' state.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> SetVibration()
        {
            Vibration body = new Vibration();
            SetVibration op = new SetVibration(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Set Vibration and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> SetVibration(Vibration body)
        {
            SetVibration op = new SetVibration();
            op.Body = body ?? new Vibration();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Query Controllers Request
        /// </summary>
        public virtual PortSet<QueryControllersResponse,Fault> QueryControllers()
        {
            QueryControllersRequest body = new QueryControllersRequest();
            QueryControllers op = new QueryControllers(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Query Controllers and return the response port.
        /// </summary>
        public virtual PortSet<QueryControllersResponse,Fault> QueryControllers(QueryControllersRequest body)
        {
            QueryControllers op = new QueryControllers();
            op.Body = body ?? new QueryControllersRequest();
            this.Post(op);
            return op.ResponsePort;

        }
    }
    
    /// <summary>
    /// Subscribe
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class Subscribe : Microsoft.Dss.ServiceModel.Dssp.Subscribe<Microsoft.Dss.ServiceModel.Dssp.SubscribeRequestType, PortSet<Microsoft.Dss.ServiceModel.Dssp.SubscribeResponseType, Fault>>
    {
        
        /// <summary>
        /// Subscribe
        /// </summary>
        public Subscribe()
        {
        }
        
        /// <summary>
        /// Subscribe
        /// </summary>
        public Subscribe(Microsoft.Dss.ServiceModel.Dssp.SubscribeRequestType body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Subscribe
        /// </summary>
        public Subscribe(Microsoft.Dss.ServiceModel.Dssp.SubscribeRequestType body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.SubscribeResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Gets the current state of the controller.
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [Description("Gets the current state of the controller.")]
    public class Get : Microsoft.Dss.ServiceModel.Dssp.Get<Microsoft.Dss.ServiceModel.Dssp.GetRequestType, PortSet<XInputGamepadState, Fault>>
    {
        
        /// <summary>
        /// Gets the current state of the controller.
        /// </summary>
        public Get()
        {
        }
        
        /// <summary>
        /// Gets the current state of the controller.
        /// </summary>
        public Get(Microsoft.Dss.ServiceModel.Dssp.GetRequestType body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Gets the current state of the controller.
        /// </summary>
        public Get(Microsoft.Dss.ServiceModel.Dssp.GetRequestType body, Microsoft.Ccr.Core.PortSet<XInputGamepadState,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Changes (or indcates a change to) the state of the controller.
    ///( Also generated when this service is started.)
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [Description("Changes (or indcates a change to) the state of the controller.\n(Also generated wh" +
        "en this service is started.)")]
    public class Replace : Microsoft.Dss.ServiceModel.Dssp.Replace<XInputGamepadState, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultReplaceResponseType, Fault>>
    {
        
        /// <summary>
        /// Changes (or indcates a change to) the state of the controller.
        ///( Also generated when this service is started.)
        /// </summary>
        public Replace()
        {
        }
        
        /// <summary>
        /// Changes (or indcates a change to) the state of the controller.
        ///( Also generated when this service is started.)
        /// </summary>
        public Replace(XInputGamepadState body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Changes (or indcates a change to) the state of the controller.
        ///( Also generated when this service is started.)
        /// </summary>
        public Replace(XInputGamepadState body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultReplaceResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Polls the controller to update the current state.
    /// If the state has changed, then appropriate notifications are sent.
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [Description("Polls the controller to update the current state.\n If the state has changed, then" +
        " appropriate notifications are sent.")]
    public class Poll : Microsoft.Dss.ServiceModel.Dssp.Submit<PollRequest, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultSubmitResponseType, Fault>>
    {
        
        /// <summary>
        /// Polls the controller to update the current state.
        /// If the state has changed, then appropriate notifications are sent.
        /// </summary>
        public Poll()
        {
        }
        
        /// <summary>
        /// Polls the controller to update the current state.
        /// If the state has changed, then appropriate notifications are sent.
        /// </summary>
        public Poll(PollRequest body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Polls the controller to update the current state.
        /// If the state has changed, then appropriate notifications are sent.
        /// </summary>
        public Poll(PollRequest body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultSubmitResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Indicates when the directional pad position changes.
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [Description("Indicates when the directional pad position changes.")]
    public class DPadChanged : Microsoft.Dss.ServiceModel.Dssp.Update<DPad, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// Indicates when the directional pad position changes.
        /// </summary>
        public DPadChanged()
        {
        }
        
        /// <summary>
        /// Indicates when the directional pad position changes.
        /// </summary>
        public DPadChanged(DPad body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Indicates when the directional pad position changes.
        /// </summary>
        public DPadChanged(DPad body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Indicates when one or more buttons are pressed or released on the controller.
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [Description("Indicates when one or more buttons are pressed or released on the controller.")]
    public class ButtonsChanged : Microsoft.Dss.ServiceModel.Dssp.Update<Buttons, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// Indicates when one or more buttons are pressed or released on the controller.
        /// </summary>
        public ButtonsChanged()
        {
        }
        
        /// <summary>
        /// Indicates when one or more buttons are pressed or released on the controller.
        /// </summary>
        public ButtonsChanged(Buttons body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Indicates when one or more buttons are pressed or released on the controller.
        /// </summary>
        public ButtonsChanged(Buttons body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Indicates when a trigger 's value when it is pressed.
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [Description("Indicates when a trigger\'s value when it is pressed.")]
    public class TriggersChanged : Microsoft.Dss.ServiceModel.Dssp.Update<Triggers, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// Indicates when a trigger 's value when it is pressed.
        /// </summary>
        public TriggersChanged()
        {
        }
        
        /// <summary>
        /// Indicates when a trigger 's value when it is pressed.
        /// </summary>
        public TriggersChanged(Triggers body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Indicates when a trigger 's value when it is pressed.
        /// </summary>
        public TriggersChanged(Triggers body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Indicates when a thumbstick position changes.
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [DisplayName("ThumbsticksChange")]
    [Description("Indicates when a thumbstick position changes.")]
    public class ThumbsticksChanged : Microsoft.Dss.ServiceModel.Dssp.Update<Thumbsticks, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// Indicates when a thumbstick position changes.
        /// </summary>
        public ThumbsticksChanged()
        {
        }
        
        /// <summary>
        /// Indicates when a thumbstick position changes.
        /// </summary>
        public ThumbsticksChanged(Thumbsticks body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Indicates when a thumbstick position changes.
        /// </summary>
        public ThumbsticksChanged(Thumbsticks body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Sets the controller (or indicates when the controller has changed or has been connected or disconnected).
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [Description("Sets the controller (or indicates when the controller has changed or has been con" +
        "nected or disconnected).")]
    public class ControllerChanged : Microsoft.Dss.ServiceModel.Dssp.Update<Controller, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// Sets the controller (or indicates when the controller has changed or has been connected or disconnected).
        /// </summary>
        public ControllerChanged()
        {
        }
        
        /// <summary>
        /// Sets the controller (or indicates when the controller has changed or has been connected or disconnected).
        /// </summary>
        public ControllerChanged(Controller body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Sets the controller (or indicates when the controller has changed or has been connected or disconnected).
        /// </summary>
        public ControllerChanged(Controller body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Sets or indicates when the controller vibration motor settings are changed.
    /// The left motor provides a low -frequency vibration; the right motor, high frequency.
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [DisplayName("SetVibrationMotor")]
    [Description("Sets or indicates when the controller vibration motor settings are changed.\nThe l" +
        "eft motor provides a low-frequency vibration; the right motor, high frequency.")]
    public class SetVibration : Microsoft.Dss.ServiceModel.Dssp.Update<Vibration, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// Sets or indicates when the controller vibration motor settings are changed.
        /// The left motor provides a low -frequency vibration; the right motor, high frequency.
        /// </summary>
        public SetVibration()
        {
        }
        
        /// <summary>
        /// Sets or indicates when the controller vibration motor settings are changed.
        /// The left motor provides a low -frequency vibration; the right motor, high frequency.
        /// </summary>
        public SetVibration(Vibration body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Sets or indicates when the controller vibration motor settings are changed.
        /// The left motor provides a low -frequency vibration; the right motor, high frequency.
        /// </summary>
        public SetVibration(Vibration body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Gets the list of attached controllers.
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [DisplayName("QueryControllers")]
    [Description("Gets the list of attached controllers.")]
    public class QueryControllers : Microsoft.Dss.ServiceModel.Dssp.Query<QueryControllersRequest, PortSet<QueryControllersResponse, Fault>>
    {
        
        /// <summary>
        /// Gets the list of attached controllers.
        /// </summary>
        public QueryControllers()
        {
        }
        
        /// <summary>
        /// Gets the list of attached controllers.
        /// </summary>
        public QueryControllers(QueryControllersRequest body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Gets the list of attached controllers.
        /// </summary>
        public QueryControllers(QueryControllersRequest body, Microsoft.Ccr.Core.PortSet<QueryControllersResponse,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
}
